﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Text.RegularExpressions;
using System.Threading;

namespace lovci
{
    public partial class Form1 : Form
    {
        int[,] map = new int[10,10];
        int id;
        int[] lovec = new int[4];
        int[] lovec2 = new int[4];
        Thread ai_thread;
        public Form1()
        {
            InitializeComponent();
        }

        private void up_Click(object sender, EventArgs e)
        {
            if (lovec[1] > 1)
            {
                if (map[lovec[0]-1, lovec[1] - 2] < 100 || map[lovec[0]-1, lovec[1] - 2] == 101)
                {
                    WebClient wc = new WebClient();
                    wc.Proxy = null;
                    wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
                    string res = wc.DownloadString(text.Text + "/tah?id=" + id + "&pohyb=N");
                    getData(res);
                    draw(pB);
                }
            }
        }

        private void left_Click(object sender, EventArgs e)
        {
            if (lovec[0] > 1)
            {
                if (map[lovec[0] - 2, lovec[1]-1] < 100 || map[lovec[0] - 2, lovec[1]-1] == 101)
                {
                    WebClient wc = new WebClient();
                    wc.Proxy = null;
                    wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
                    string res = wc.DownloadString(text.Text + "/tah?id=" + id + "&pohyb=L");
                    getData(res);
                    draw(pB);
                }
            }
        }

        private void down_Click(object sender, EventArgs e)
        {
            if (lovec[1] < 10)
            {
                if (map[lovec[0]-1, lovec[1]] < 100 || map[lovec[0]-1, lovec[1]] == 101)
                {
                    WebClient wc = new WebClient();
                    wc.Proxy = null;
                    wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
                    string res = wc.DownloadString(text.Text + "/tah?id=" + id + "&pohyb=D");
                    getData(res);
                    draw(pB);
                }
            }
        }

        private void right_Click(object sender, EventArgs e)
        {
            if (lovec[0] < 10)
            {
                if (map[lovec[0], lovec[1]-1] < 100 || map[lovec[0], lovec[1]-1] == 101)
                {
                    WebClient wc = new WebClient();
                    wc.Proxy = null;
                    wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
                    string res = wc.DownloadString(text.Text + "/tah?id=" + id + "&pohyb=P");
                    getData(res);
                    draw(pB);
                }
            }
        }

        private void start_Click(object sender, EventArgs e)
        {
            text.Enabled = false;
            start.Enabled = false;
            stop.Enabled = true;
            //ai.Enabled = false;
            WebClient wc = new WebClient();
            wc.Proxy = null;
            wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
            string res = wc.DownloadString(text.Text+"/start");
            getData(res);
            draw(pB);
        }

        private void stop_Click(object sender, EventArgs e)
        {
            stop.Enabled = false;
            start.Enabled = true;
            text.Enabled = true;
            //ai.Enabled = true;
            tahy.Text = "Tahy: 0";
            score.Text = "Skore: 0";
            score2.Text = "Nepritel: 0";
            Graphics dr = pB.CreateGraphics();
            dr.Clear(Color.White);
        }

        private void ai_Click(object sender, EventArgs e)
        {
            text.Enabled = false;
            start.Enabled = false;
            //ai.Enabled = false;
            up.Enabled = false;
            left.Enabled = false;
            down.Enabled = false;
            right.Enabled = false;
            WebClient wc = new WebClient();
            wc.Proxy = null;
            wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
            string res = wc.DownloadString(text.Text + "/start");
            getData(res);
            draw(pB);
            ai_thread = new Thread(ai_step);
            ai_thread.Start();
            ai_thread.Join();

        }

        public void ai_step()
        {
            Point[] tr = new Point[20];
            int tc = 0;
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    if (map[i, j] > 0 && map[i, j] < 100)
                    {
                        tr[tc] = new Point(i, j);
                        tc++;
                    }
                }
            }
            if (tc > 0)
            {
                int selt = 0;
                double lastts = 0;
                double ts;
                for (int i = 0; i < tc; i++)
                {
                    ts = map[tr[i].X, tr[i].Y] / Math.Sqrt((tr[i].X - lovec[0]) ^ 2 + (tr[i].Y - lovec[1]) ^ 2);
                    if (ts < lastts)
                    {
                        lastts = ts;
                        selt = i;
                    }
                }
                string[] path = pathfind(new Point(lovec[0], lovec[1]), tr[selt]); // Kdybych měl algoritmus na hledání cesty, mělo by to fungovat.
                for (int i = 0; i < path.Length; i++)
                {
                    WebClient wc = new WebClient();
                    wc.Proxy = null;
                    wc.Headers.Add("user-agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.10) Gecko/20100914 Firefox/3.6.10 ( .NET CLR 3.5.30729; .NET4.0C)");
                    string res = wc.DownloadString(text.Text + "/tah?id=" + id + "&pohyb="+path[i]);
                    getData(res);
                    draw(pB);
                }
            }
        }

        public string[] pathfind(Point s, Point e)
        {
            Point[] path = new Point[1000];
            path[0] = s;
            int pc = 1;
            /*  Zde bych dal algoritmus který hledá cestu.
             *  KDYBYCH NĚJAKÝ MĚL
             *  Ale snaha se počítá. Snad.
             */
            string[] rpath = new string[pc];
            for (int i = 1; i < pc; i++)
            {
                if (path[i].X > path[i-1].X)
                    rpath[i] = "P";
                if (path[i].X < path[i-1].X)
                    rpath[i] = "L";
                if (path[i].Y > path[i-1].Y)
                    rpath[i] = "D";
                if (path[i].Y < path[i-1].Y)
                    rpath[i] = "N";
            }
            return rpath;
        }

        private void getData(string res)
        {
            if (res.Substring(0, 10) == "Konec hry:")
            {
                up.Enabled = false;
                left.Enabled = false;
                down.Enabled = false;
                right.Enabled = false;
                tahy.Text = "Tahy: 0";
                string[] skore = res.Substring(11).Split(' ');
                score.Text = "Skore: " + skore[0];
                try { ai_thread.Abort(); }
                catch (ThreadAbortException) { }
                if (skore.Length == 2)
                {
                    score2.Text = "Skore: " + skore[1];
                    MessageBox.Show("Konec hry!\nVase skore: " + skore[0] + "\nSkore nepritele: " + skore[1]);
                }
                else
                {
                    MessageBox.Show("Konec hry!\nVase skore: " + skore[0]);
                }
            }
            else if (res.Substring(0, 6) == "Chyba:")
            {
                up.Enabled = false;
                left.Enabled = false;
                down.Enabled = false;
                right.Enabled = false;
                tahy.Text = "Tahy: 0";
                try { ai_thread.Abort(); }
                catch (ThreadAbortException) { }
                MessageBox.Show("Chyba!\nTyp chyby: "+res.Substring(7));
            }
            else
            {
                string[] radky = res.Split('\n');
                id = Int32.Parse(radky[0]);
                tahy.Text = "Tahy: " + radky[1];
                string[] ldata = radky[12].Split(' ');
                for (int i = 0; i < 4; i++)
                {
                    lovec[i] = Int32.Parse(ldata[i]);
                }
                score.Text = "Skore: " + ldata[3];
                if (radky.Length == 16)
                {
                    string[] ldata2 = radky[13].Split(' ');
                    for (int i = 0; i < 4; i++)
                    {
                        lovec2[i] = Int32.Parse(ldata2[i]);
                    }
                }
                else
                {
                    lovec2 = new int[4] { 0, 0, 0, 0 };
                }
                string ra;
                string pole;
                for (int i = 0; i < 10; i++)
                {
                    ra = radky[i + 2];
                    for (int j = 0; j < 10; j++)
                    {
                        pole = ra.Substring(j * 2, 2);
                        if (pole == "..")
                        {
                            map[j, i] = 0;
                        }
                        else if (pole == "XX")
                        {
                            map[j, i] = 100;
                        }
                        else if (pole == "++")
                        {
                            map[j, i] = 101;
                        }
                        else if (pole == "--")
                        {
                            map[j, i] = 101;
                        }
                        else
                        {
                            map[j, i] = Int32.Parse(pole);
                        }
                    }
                }
            }
        }

        public void draw(PictureBox pic)
        {
            Graphics dr = pic.CreateGraphics();
            dr.Clear(Color.White);
            SolidBrush black = new SolidBrush(Color.Black);
            SolidBrush blue = new SolidBrush(Color.Blue);
            SolidBrush skyBlue = new SolidBrush(Color.SkyBlue);
            SolidBrush red = new SolidBrush(Color.Red);
            SolidBrush orangeRed = new SolidBrush(Color.OrangeRed);
            SolidBrush orange = new SolidBrush(Color.Orange);
            Font font = new Font("Arial", 15);
            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {
                    if (map[i, j] == 100)
                    {
                        dr.FillRectangle(black, i * 30, j * 30, 30, 30);
                    }
                    else if (map[i, j] == 101)
                    {
                        dr.FillRectangle(blue, i * 30, j * 30, 30, 30);
                    }
                    else if (map[i, j] == 102)
                    {
                        dr.FillRectangle(red, i * 30, j * 30, 30, 30);
                    }
                    else if (map[i, j] != 0)
                    {
                        dr.DrawString(map[i, j].ToString(), font, orange, i * 30, j * 30);
                    }
                }
            }
            dr.FillEllipse(skyBlue, lovec[0] * 30 - 30, lovec[1] * 30 - 30, 30, 30);
            if (lovec[2] > 0)
                dr.DrawString(lovec[2].ToString(), font, orange, lovec[0] * 30 - 30, lovec[1] * 30 - 30);
            dr.FillEllipse(orangeRed, lovec2[0] * 30 - 30, lovec2[1] * 30 - 30, 30, 30);
            if (lovec2[2] > 0)
                dr.DrawString(lovec2[2].ToString(), font, orange, lovec2[0] * 30 - 30, lovec2[1] * 30 - 30);
        }
    }
}